# TODO: ruby (when ready)
#
# Conditional build:
%bcond_without	evas	# Edisplay support
%bcond_without	gif	# GIF support
%bcond_without	lua	# Lua API
%bcond_without	perl	# Perl API
%bcond_without	php	# PHP API
%bcond_without	python	# Python API
%bcond_with	ruby	# Ruby API [not finished as of 0.8.9]

%define		php_name	php%{?php_suffix}
%include	/usr/lib/rpm/macros.perl
Summary:	A fast, modern and generic image processing library
Summary(pl.UTF-8):	Szybka, nowoczesna i ogólna biblioteka do przetwarzania obrazu
Name:		exact-image
Version:	0.8.9
Release:	9
License:	GPL v2
Group:		Applications/Graphics
Source0:	http://dl.exactcode.de/oss/exact-image/%{name}-%{version}.tar.bz2
# Source0-md5:	a8694722cd7cc9aa9407950a8440f0cd
Patch0:		%{name}-libs.patch
Patch1:		exactimage_0.8.5-1.patch
Patch2:		%{name}-giflib.patch
Patch3:		%{name}-evas.patch
Patch4:		%{name}-install.patch
Patch5:		swig.patch
URL:		http://www.exactcode.de/site/open_source/exactimage/
BuildRequires:	OpenEXR-devel >= 1.2.0
BuildRequires:	agg-devel >= 2.3
%{?with_evas:BuildRequires:	evas-devel >= 0.9.9}
BuildRequires:	expat-devel
# pkgconfig(freetype) >= 9.5.0
BuildRequires:	freetype-devel >= 2.1.6
%{?with_gif:BuildRequires:	giflib-devel >= 5}
BuildRequires:	jasper-devel
BuildRequires:	lcms-devel >= 1.10
BuildRequires:	libjpeg-devel
BuildRequires:	libpng-devel >= 2:1.5
BuildRequires:	libstdc++-devel
BuildRequires:	libtiff-devel
%{?with_lua:BuildRequires:	lua51-devel >= 5.1}
BuildRequires:	perl-devel >= 1:5.8.0
%{?with_php:BuildRequires:	%{php_name}-devel >= 5.2.0}
BuildRequires:	pkgconfig
%{?with_python:BuildRequires:	python-devel >= 1:2.5.0}
BuildRequires:	rpm-perlprov
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.219
%{?with_ruby:BuildRequires:	ruby-devel >= 1.8.5}
%{?with_perl:BuildRequires:	swig-perl >= 1.3.32}
%{?with_php:BuildRequires:	swig-php >= 1.3.32}
%{?with_python:BuildRequires:	swig-python >= 1.3.32}
BuildRequires:	xorg-lib-libX11-devel >= 1.3
BuildRequires:	zlib-devel
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
A fast, modern and generic (template based) C++ image processing
library, alternative to ImageMagick.

%description -l pl.UTF-8
Szybka, nowoczesna i ogólna (oparta na szablonach) biblioteka C++
do przetwarzania obrazu, będąca alternatywą dla biblioteki
ImageMagick.

%package -n lua-ExactImage
Summary:	ExactImage API for Lua language
Summary(pl.UTF-8):	API ExactImage dla języka Lua
Group:		Development/Languages
Requires:	lua51

%description -n lua-ExactImage
ExactImage API for Lua language.

%description -n lua-ExactImage -l pl.UTF-8
API ExactImage dla języka Lua.

%package -n perl-ExactImage
Summary:	ExactImage API for Perl
Summary(pl.UTF-8):	API ExactImage dla Perla
Group:		Development/Languages/Perl

%description -n perl-ExactImage
ExactImage API for Perl.

%description -n perl-ExactImage -l pl.UTF-8
API ExactImage dla Perla.

%package -n %{php_name}-ExactImage
Summary:	ExactImage API for PHP
Summary(pl.UTF-8):	API ExactImage dla PHP
Group:		Development/Languages/Perl
%{?requires_php_extension}

%description -n %{php_name}-ExactImage
ExactImage API for PHP.

%description -n %{php_name}-ExactImage -l pl.UTF-8
API ExactImage dla PHP.

%package -n python-ExactImage
Summary:	ExactImage API for Python
Summary(pl.UTF-8):	API ExactImage dla Pythona
Group:		Development/Languages/Python

%description -n python-ExactImage
ExactImage API for Python.

%description -n python-ExactImage -l pl.UTF-8
API ExactImage dla Pythona.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

%build
./configure \
	--prefix=%{_prefix} \
	%{!?with_evas:--without-evas} \
	%{!?with_gif:--without-libungif} \
	%{!?with_lua:--without-lua} \
	%{!?with_perl:--without-perl} \
	%{!?with_php:--without-php} \
	%{!?with_python:--without-python}

%{__make} \
	CC="%{__cc}" \
	CXX="%{__cxx}" \
	CFLAGS="%{rpmcflags}" \
	CXXFLAGS="%{rpmcflags}" \
	Q=

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	PERL_INSTALLDIR=%{perl_vendorarch} \
	PHP_INSTALLDIR=%{php_extensiondir} \
	PYTHON_LIBDIR=%{py_sitedir} \
	api/lua/libdir=%{_libdir}/lua \
	Q=

%if %{with python}
%py_comp $RPM_BUILD_ROOT%{py_sitedir}
%py_ocomp $RPM_BUILD_ROOT%{py_sitedir}
%py_postclean
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc README TODO
%attr(755,root,root) %{_bindir}/bardecode
%attr(755,root,root) %{_bindir}/e2mtiff
%attr(755,root,root) %{_bindir}/econvert
%attr(755,root,root) %{_bindir}/edentify
%{?with_evas:%attr(755,root,root) %{_bindir}/edisplay}
%attr(755,root,root) %{_bindir}/empty-page
%attr(755,root,root) %{_bindir}/hocr2pdf
%attr(755,root,root) %{_bindir}/optimize2bw

%if %{with lua}
%files -n lua-ExactImage
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/lua/ExactImage.so
%endif

%if %{with perl}
%files -n perl-ExactImage
%defattr(644,root,root,755)
%attr(755,root,root) %{perl_vendorarch}/ExactImage.so
%{perl_vendorarch}/ExactImage.pm
%endif

%if %{with php}
%files -n %{php_name}-ExactImage
%defattr(644,root,root,755)
%attr(755,root,root) %{php_extensiondir}/ExactImage.so
%{php_extensiondir}/ExactImage.php
%endif

%if %{with python}
%files -n python-ExactImage
%defattr(644,root,root,755)
%attr(755,root,root) %{py_sitedir}/_ExactImage.so
%{py_sitedir}/ExactImage.py[co]
%endif
%changelog
* Sun Oct 30 2016 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/exact-image.git;a=log;h=auto/th/exact-image-0.8.9-9

* Sun Oct 30 2016 Jan Rękorajski <baggins@pld-linux.org> 77b4403
- rebuild with perl 5.24.0
- release 9 (by relup.sh)

* Sun Dec 27 2015 Jan Rękorajski <baggins@pld-linux.org> 47abdb9
- new swig does not like language specific comments
- rel 8

* Fri Dec 25 2015 Jan Rękorajski <baggins@pld-linux.org> 076b86f
- release 7 (by relup.sh)

* Thu Dec 24 2015 Jan Rękorajski <baggins@pld-linux.org> 511153c
- release 6 (by relup.sh)

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 44eaf9d
- release 5 (by relup.sh)

* Sun Oct 26 2014 Jan Rękorajski <baggins@pld-linux.org> d43c383
- release 4 (by relup.sh)

* Wed Oct 22 2014 Jakub Bogusz <qboosh@pld-linux.org> 60c6ac0
- release 3

* Tue Oct 21 2014 Jakub Bogusz <qboosh@pld-linux.org> 84d0248
- php install fix
- no reason to disable lua/perl/python on x86_64

* Tue Oct 21 2014 Jakub Bogusz <qboosh@pld-linux.org> 67a43a7
- build also PHP API

* Tue Oct 21 2014 Jakub Bogusz <qboosh@pld-linux.org> af9f5a1
- added install patch (allow to pass some module install paths), package lua,perl,python bindings

* Mon Oct 20 2014 Jakub Bogusz <qboosh@pld-linux.org> c103766
- added evas patch (fixes build with evas 1.8+)

* Mon Oct 20 2014 Jakub Bogusz <qboosh@pld-linux.org> e293edf
- added giflib patch (giflib 5+ support, covers both 5.0 and 5.1+)

* Sun Oct 19 2014 Jakub Bogusz <qboosh@pld-linux.org> 1d474b6
- added pl, some bconds and verbose build

* Mon Oct 06 2014 Tomasz Pala <gotar@pld-linux.org> fcc4b36
- try some PNG 1.5 patch available
https://bugs.debian.org/cgi-bin/bugreport.cgi?msg=15;filename=exactimage_0.8.5-1.patch;att=1;bug=635745

* Mon Oct 06 2014 Tomasz Pala <gotar@pld-linux.org> 8a83c4c
- disabled GIF as well

* Mon Oct 06 2014 Tomasz Pala <gotar@pld-linux.org> fc08e2a
- as the builders refuse to install libpng12-devel, disabled PNG again

* Mon Oct 06 2014 Tomasz Pala <gotar@pld-linux.org> ad41e95
- upgraded to 0.8.9, reenabled PNG support

* Wed Apr 16 2014 Jan Rękorajski <baggins@pld-linux.org> 3704201
- BR giflib4

* Tue Apr 02 2013 Jan Rękorajski <baggins@pld-linux.org> d49518a
- updated to 0.8.8

* Mon Nov 12 2012 Jan Rękorajski <baggins@pld-linux.org> 170caa0
- fix building with gcc 4.7
- rel 4

